routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index' );

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::resource('/categories', 'CategoryController');

Route::resource('/types', 'TypeController');

Route::get('/preferences', 'PreferencesController@index')
		->name('preferences.index');
Route::get('/preferences/{preferences}/unit', 'PreferencesController@editUnit')
		->name('preferences.editUnit');
Route::put('/preferences/{preferences}/unit', 'PreferencesController@updateUnit')
		->name('preferences.updateUnit');

Route::resource('/widths', 'WidthsController');

Route::resource('/contacts', 'ContactsController');

// Actions Handled By Resource Controller

// Verb 		URI 					Action 		Route Name
// GET			/photos					index		photos.index
// GET			/photos/create 			create 		photos.create
// POST			/photos					store		photos.store
// GET			/photos/{photo}			show		photos.show
// GET			/photos/{photo}/edit	edit		photos.edit
// PUT/PATCH	/photos/{photo}			update		photos.update
// DELETE		/photos/{photo}			destroy		photos.destroy

app/Widths.php
<?php

namespace App;

use App\PW\Helpers\Units;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;

class Widths extends Model
{
    //
    //
	protected $fillable = [
		'amount',
	];

	public $timestamps = false;

	public function getAmountAttribute( $value )
	{
		return round( Units::convertInchesToUnit( $value ) , 3 );
	}
}

app/Http/Controllers/WidthsController.php
<?php

namespace App\Http\Controllers;

use App\PW\Facades\Units;
use App\User;
use App\Widths;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class WidthsController extends Controller
{
	/**
	 * Create a new controller instance.
	 *
	 * @return void
	 */
	public function __construct()
	{
		$this->middleware('auth');
	}

	/**
	 * Display a listing of the resource.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function index()
	{
		//
		$widths = Widths::all();

		return view('widths.index', compact('widths'));
	}

	/**
	 * Show the form for creating a new resource.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function create()
	{
		//
		$preferences = Auth::user()->preferences;

		return view( 'widths.new', compact('preferences'));
	}

	/**
	 * Store a newly created resource in storage.
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function store(Request $request)
	{
		//
		$this->validate($request, [
			'amount' => 'required|between:0.001,20000',
		]);

		$width = new Widths;

		/*$amount = Helpers::convertUnit( $request->amount );*/

		$width->amount = Units::convertUnitToInches( $request->amount, $request->units );

		$width->save();

		return redirect( route('widths.index') )->with('message', 'Successfully added a new Film Width.');
	}

	/**
	 * Display the specified resource.
	 *
	 * @param  \App\Widths  $widths
	 * @return \Illuminate\Http\Response
	 */
	public function show(Widths $widths)
	{
		//
	}

	/**
	 * Show the form for editing the specified resource.
	 *
	 * @param  \App\Widths  $widths
	 * @return \Illuminate\Http\Response
	 */
	public function edit(Widths $width)
	{
		//

	}

	/**
	 * Update the specified resource in storage.
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @param  \App\Widths  $widths
	 * @return \Illuminate\Http\Response
	 */
	public function update(Request $request, Widths $widths)
	{
		//
	}

	/**
	 * Remove the specified resource from storage.
	 *
	 * @param  \App\Widths  $widths
	 * @return \Illuminate\Http\Response
	 */
	public function destroy(Widths $width)
	{
		//
		$message = 'Could not delete Film Width. Width ID: ' . $width->id;

		if ( $width->delete() )
		{
			$message = 'Successfully deleted Film Width.';
		}

		return redirect( route( 'widths.index' ) )->with( 'message', $message );
	}
}

resources/views/widths/editUnit.blade.php
@extends( 'layouts.app' )

@section( 'pageTitle', 'Preferences' )

@section('breadcrumbs')

	<ol class="breadcrumb bg-faded">
		<li class="breadcrumb-item"><a href="{{ url('/') }}">Home</a></li>
		<li class="breadcrumb-item"><a href="{{ route('preferences.index') }}">Preferences</a></li>
		<li class="breadcrumb-item active">Edit Units</li>
	</ol>

@endsection

@section( 'content' )
	<h1>Edit Units</h1>

	<form action="{{ route( 'preferences.updateUnit', $preferences->id ) }}" method="POST">
		{{ csrf_field() }}
		{{ method_field('PUT') }}

		@php
		$units = [
					'inches',
					'centimeters',
				];

		@endphp
		<div class="form-group{{ $errors->has('unit') ? ' has-danger' : '' }}">
			<label for="preferenceUnit">Preferred Unit of Measure</label>
			<select class="form-control" id="preferenceUnit" name="unit">
				@foreach( $units as $unit )
				<option value="{{ $unit }}" @if( $unit == $preferences->unit ) selected @endif>
					{{ ucwords( $unit ) }}
				</option>
				@endforeach
			</select>
		</div>
		<div class="form-group">
			<button type="submit" class="btn btn-primary btn-block">
				<span class="fa fa-disk"></span>
				Update
			</button>
			<a href="{{ route('preferences.index') }}" class="btn btn-secondary btn-block">
				Cancel
			</a>
		</div>
	</form>
@endsection

resources/views/widths/index.blade.php
@extends( 'layouts.app' )

@section( 'pageTitle', 'Film Widths' )

@section('breadcrumbs')

	<ol class="breadcrumb bg-faded">
		<li class="breadcrumb-item"><a href="{{ url('/') }}">Home</a></li>
		<li class="breadcrumb-item active">Film Widths</li>
	</ol>

@endsection

@section( 'content' )
	<h1>Film Widths</h1>

	<p>
		<a href="{{ route('widths.create') }}" class="btn btn-info btn-block">
			<span class="fa fa-plus-square-o"></span>
			New Film Width
		</a>
	</p>

	<div class="card-columns">
		@foreach( $widths as $width )
		<div class="card">

			<div class="card-block">

				<h4 class="card-title h5">
					<span class="fa fa-arrows-h"></span>
					Measuring Units
				</h4>

				<p>
					{{ Units::convertInchesToUnit( $width->amount ) }} {{ Units::getAbbreviation() }}
				</p>

			</div>

			<div class="card-footer">
				<form id="deleteForm{{ $width->id }}" action="{{ route( 'widths.destroy', $width->id ) }}" method="POST">
					{{ csrf_field() }}
					{{ method_field('DELETE') }}

					<div class="form-group">
						<a href="{{ route('widths.edit', $width->id) }}" class="btn btn-secondary btn-block btn-sm">
							<span class="fa fa-pencil"></span>
							Edit
						</a>
					</div>

					<button type="button" class="btn btn-outline-danger btn-block btn-sm" data-toggle="modal" data-target="#deleteConfirmModal" data-id="{{ $width->id }}">
						<span class="fa fa-trash"></span> 
						Delete
					</button>
					
				</form>
			</div>

		</div>
		@endforeach
	</div>

	@if ( $widths->count() < 1 )
	<p>
		There are no Film Widths to display.
	</p>
	@endif

	<p>
		<a href="{{ route('widths.create') }}" class="btn btn-info btn-block">
			<span class="fa fa-plus-square-o"></span>
			New Film Width
		</a>
	</p>
 	
	<div class="modal fade" id="deleteConfirmModal" tabindex="-1" role="dialog" aria-labelledby="deleteConfirmModalLabel" aria-hidden="true">
		<div class="modal-dialog" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<h5 class="modal-title" id="deleteConfirmModalLabel">Are you sure?</h5>
					<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true">&times;</span>
					</button>
				</div>
				<div class="modal-body">
					<p>
						Do you really want to delete this item?
					</p>
				<div class="modal-footer">

					<button id="btnModalConfirm" type="button" class="btn btn-primary">Yes</button>
					<button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>

				</div>
			</div>
		</div>
	</div>
@endsection

@section('pageScript')
	<script type="text/javascript">
		$('#deleteConfirmModal').on('show.bs.modal', function (event) {
			var button = $(event.relatedTarget); // Button that triggered the modal
			var typeId = button.data('id'); // Extract info from data-* attributes
			// If necessary, you could initiate an AJAX request here (and then do the updating in a callback).
			// Update the modal's content. We'll use jQuery here, but you could use a data binding library or other methods instead.
			// var modal = $(this);

			$('#btnModalConfirm').click( function() {

				var modal = $('.modal');
				
				modal.modal('hide');

				$('#deleteForm' + typeId).submit();

			});

		})
	</script>
@endsection

resources/views/widths/new.blade.php
@extends('layouts.app')

@section('pageTitle', 'New Film Width')

@section('breadcrumbs')

	<ol class="breadcrumb bg-faded">
		<li class="breadcrumb-item"><a href="{{ url('/') }}">Home</a></li>
		<li class="breadcrumb-item"><a href="{{ route('widths.index') }}">Film Widths</a></li>
		<li class="breadcrumb-item active">New Film Width</li>
	</ol>

@endsection

@section('content')

	<h1>New Film Width</h1>

	<form action="{{ route('widths.store') }}" method="POST">
		{{ csrf_field() }}
		<fieldset class="form-group{{ $errors->has('name') ? ' has-danger' : '' }}">
			<div class="input-group">
				<input 	type="number"
						name="amount"
						required="true"
						autocomplete="off"
						step="0.001"
						min="0.001"
						class="input-group-addon"
						id="filmWidthAmount"
					value="{{ old('amount') }}">
				<select name="units" class="input-group-addon">
					@foreach( Units::unitList() as $unit )
						<option value="{{ $unit }}" @if( $preferences->unit == $unit ) selected @endif >
							{{ Units::abbreviations( $unit ) }}
						</option>
					@endforeach
				</select>
			</div>
		</fieldset>
		<fieldset class="form-group">
			<button type="submit" class="btn btn-primary btn-block">
				<span class="fa fa-disk"></span>
				Save
			</button>
			<a href="{{ route('widths.index') }}" class="btn btn-secondary btn-block">
				Cancel
			</a>
		</fieldset>
	</form>

@endsection